{-# LANGUAGE TemplateHaskell #-}
module Precomputer
  ( runDeps
  , formatDependencyTrees
  ) where

import qualified DependencyRunner as DR
import qualified Types.Dependency as D
import SiteGenerator (generateSite)
import DependencyGenerator (evalDepGenM)

import qualified Data.Text.IO as T
import Language.Haskell.TH.Syntax

runDeps :: Code Q (IO ())
runDeps = [|| DR.runDepRunMIO (DR.runDeps (evalDepGenM generateSite)) ||]

formatDependencyTrees :: Code Q (IO ())
formatDependencyTrees = [|| T.putStr (D.formatDependencyTrees (evalDepGenM generateSite)) ||]
